'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _panelItem = require('./panel-item');

var _panelItem2 = _interopRequireDefault(_panelItem);

var _styleSheetBuilder = require('./style-sheet-builder');

var _styleSheetBuilder2 = _interopRequireDefault(_styleSheetBuilder);

require('./panel.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HorizontalPanel = function (_React$Component) {
    _inherits(HorizontalPanel, _React$Component);

    function HorizontalPanel(props) {
        _classCallCheck(this, HorizontalPanel);

        var _this = _possibleConstructorReturn(this, (HorizontalPanel.__proto__ || Object.getPrototypeOf(HorizontalPanel)).call(this, props));

        _this.state = {};

        _this.styleElement = null;

        _this.isVertical = _this.props.isVertical == true ? true : false;
        _this.spacing = _this.props.spacing ? _this.props.spacing : 5;
        _this.responsive = _this.props.responsive == false ? false : true;
        _this.responsiveWidth = _this.props.responsiveWidth ? _this.props.responsiveWidth : 700;

        _this.id = "horizontal-panel-" + HorizontalPanelIdIncrementor.create();
        return _this;
    }

    _createClass(HorizontalPanel, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.responsive == true) {
                var style = new _styleSheetBuilder2.default();
                var styleFirst = new _styleSheetBuilder2.default();

                style.add("width", "auto !important");
                style.add("display", "block !important");
                style.add("float", "none !important");
                style.add("margin-left", "0 !important");
                style.add("margin-right", "0 !important");
                style.add("padding-left", "0 !important");
                style.add("padding-right", "0 !important");
                style.add("padding-top", this.spacing + "px !important");

                styleFirst.add("padding-top", "0 !important");

                var cssText = "@media all and (max-width: " + this.responsiveWidth + "px) {" + ".panel-component[data-panel-component-id=" + this.id + "] " + ">" + " .panel-item-component[data-panel-item-component-id] {" + style.toString() + "}" + ".panel-component[data-panel-component-id=" + this.id + "] " + ">" + " .panel-item-component[data-panel-item-component-id]:first-child {" + styleFirst.toString() + "}" + "}";

                this.styleElement.innerText = cssText;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var pannelStyle = {};

            if (!this.isVertical) {
                //pannelStyle.whiteSpace = "nowrap";
            }

            if (Object.prototype.toString.call(this.props.children) === '[object Array]') {
                var children = this.props.children.filter(function (c) {
                    return c;
                });
            } else {
                var children = this.props.children;
            }

            var extendChildProps = function extendChildProps(child, props, index) {
                props.spacing = _this2.spacing;
                props.isVertical = _this2.isVertical;

                props.isChild = _this2.props.isChild;
                props.responsive = _this2.responsive;
                props.responsiveWidth = _this2.responsiveWidth;
            };

            var extendedChildren = children;
            var hasFloat = undefined;
            if (children && children.length > 1) {
                // if doesn't have fixed OR vertical
                if (children.filter(function (child) {
                    return child.props.width > 0;
                }).length == 0 || this.isVertical == true) {
                    var width = 100 / children.length + "%";
                    var display = "inline-block";

                    extendedChildren = _react2.default.Children.map(children, function (child, index) {
                        var props = {
                            width: width,
                            display: display,
                            isFirstHorizontal: index == 0,
                            isFirst: index == 0,
                            isLast: children.length == index + 1
                        };

                        extendChildProps(child, props, index);

                        return _react2.default.cloneElement(child, props);
                    });
                } else {
                    var autoMarginLeft = 0;
                    var autoMarginRight = 0;
                    var autoItemIndex = undefined;

                    // init marging
                    var wrappers = _react2.default.Children.map(children, function (child, index) {
                        var wrapper = {
                            width: child.props.width,
                            isAuto: undefined,
                            float: undefined,
                            index: index
                            // auto
                        };if (wrapper.width == undefined) {
                            wrapper.isAuto = true;
                            autoItemIndex = index;
                        }
                        // width
                        else {
                                // float - left
                                if (index < autoItemIndex || autoItemIndex == undefined) {
                                    autoMarginLeft += wrapper.width;
                                    wrapper.float = "left";
                                }
                                // float - right
                                else {
                                        autoMarginRight += wrapper.width;
                                        wrapper.float = "right";
                                    }
                                hasFloat = true;
                            }

                        return wrapper;
                    });

                    // move "auto" to last position
                    if (autoItemIndex != undefined) {
                        var wrapper = wrappers[autoItemIndex];
                        wrappers.splice(autoItemIndex, 1);
                        wrappers.push(wrapper);
                    }

                    extendedChildren = wrappers.map(function (wrapper, index) {
                        var child = children[wrapper.index];
                        var props = {
                            width: wrapper.width,
                            float: wrapper.float,
                            isFirstHorizontal: wrapper.index == 0,
                            isFirst: index == 0,
                            isLast: children.length == index + 1,
                            key: index
                        };

                        if (wrapper.isAuto) {
                            props.marginLeft = autoMarginLeft;
                            props.marginRight = autoMarginRight;
                        }

                        extendChildProps(child, props, index);

                        return _react2.default.cloneElement(child, props);
                    });
                }
            }
            return _react2.default.createElement(
                'div',
                { className: "panel-component", style: pannelStyle, 'data-panel-component-id': this.id },
                extendedChildren,
                hasFloat && _react2.default.createElement('div', { className: 'clear-fix' }),
                _react2.default.createElement('style', { ref: function ref(x) {
                        return _this2.styleElement = x;
                    } })
            );
        }
    }]);

    return HorizontalPanel;
}(_react2.default.Component);

exports.default = HorizontalPanel;


HorizontalPanel.propTypes = {
    children: function children(props, propName, componentName) {
        var prop = props[propName];
        var error = null;
        var fixedWidthCount = 0;
        var autoWidthCount = 0;

        _react2.default.Children.forEach(prop, function (child) {
            if (child == null) {
                return; // null instead of PanelItem allowed
            }
            if (child.type !== _panelItem2.default) {
                error = new Error('' + componentName + ' children should be of type "PanelItem".');
            }
            if (child.width == undefined) {
                autoWidthCount++;
            } else {
                fixedWidthCount++;
            }
        });

        if (fixedWidthCount > 0) {
            if (autoWidthCount > 1) {
                error = new Error("If HorizontalPanel has at least one fixed-width PanelItem it should have only one auto-width PanelItem.");
            }
        }

        return error;
    }
};

if (typeof window !== "undefined" && window.HorizontalPanelIdIncrementor == null) {
    window.HorizontalPanelIdIncrementor = new function () {
        var self = this;
        self._id = 0;
        self.create = function () {
            self._id++;
            return self._id;
        };
    }();
}