'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _horizontalPanel = require('./horizontal-panel');

var _horizontalPanel2 = _interopRequireDefault(_horizontalPanel);

var _verticalPanel = require('./vertical-panel');

var _verticalPanel2 = _interopRequireDefault(_verticalPanel);

var _styleSheetBuilder = require('./style-sheet-builder');

var _styleSheetBuilder2 = _interopRequireDefault(_styleSheetBuilder);

require('./panel-item.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PanelItem = function (_React$Component) {
    _inherits(PanelItem, _React$Component);

    function PanelItem(props) {
        _classCallCheck(this, PanelItem);

        var _this = _possibleConstructorReturn(this, (PanelItem.__proto__ || Object.getPrototypeOf(PanelItem)).call(this, props));

        _this.state = {};

        _this.spacing = _this.props.spacing ? _this.props.spacing : 5;

        _this.id = "panel-item-" + PanelItemIdIncrementor.create();
        return _this;
    }

    _createClass(PanelItem, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            var props = this.props;

            var style = new _styleSheetBuilder2.default();

            if (props.isVertical == true) {
                if (this.spacing) {
                    style.addPx("padding-top", this.spacing);
                }

                if (props.isFirst) {
                    style.addPx("padding-top", 0);
                }
            } else {
                style.addPx("width", props.width);

                style.add("display", props.display);
                style.add("float", props.float);

                style.addPx("margin-left", props.marginLeft);
                style.addPx("margin-right", props.marginRight);

                if (this.spacing) {
                    style.addPx("padding-top", props.spacing);
                    style.addPx("padding-left", props.spacing);
                    style.addPx("padding-bottom", props.spacing);
                }

                if (props.isFirstHorizontal) {
                    style.paddingLeft = 0;
                    style.addPx("padding-left", 0);
                }

                if (props.isChild) {
                    style.addPx("padding-top", 0);
                    style.addPx("padding-bottom", 0);
                }
            }

            var children = _react2.default.Children.map(this.props.children, function (child, index) {
                var element = child;
                if (child && (child.type == _horizontalPanel2.default || child.type == _verticalPanel2.default)) {

                    var extendProps = {
                        isChild: true,
                        spacing: _this2.spacing
                    };

                    // pass responsive
                    if (child.props.responsive == undefined && _this2.props.responsive != undefined) {
                        extendProps.responsive = _this2.props.responsive;
                    }

                    // pass responsiveWidth
                    if (child.props.responsiveWidth == undefined && _this2.props.responsiveWidth != undefined) {
                        extendProps.responsiveWidth = _this2.props.responsiveWidth;
                    }

                    element = _react2.default.cloneElement(child, extendProps);
                }
                return element;
            });

            children = children ? children.filter(function (child) {
                return child;
            }) : null;

            return _react2.default.createElement(
                'div',
                { className: 'panel-item-component', 'data-panel-item-component-id': this.id },
                children,
                _react2.default.createElement(
                    'style',
                    null,
                    " .panel-item-component[data-panel-item-component-id=" + this.id + "] { " + style.toString() + " }"
                )
            );
        }
    }]);

    return PanelItem;
}(_react2.default.Component);

exports.default = PanelItem;


if (typeof window !== "undefined" && window.PanelItemIdIncrementor == null) {
    window.PanelItemIdIncrementor = new function () {
        var self = this;
        self._id = 0;
        self.create = function () {
            self._id++;
            return self._id;
        };
    }();
}

//export { PanelItem }