"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var StyleSheetBuilder = function StyleSheetBuilder() {
    var _this = this;

    this.items = [];
    this.add = function (name, value, ending) {

        var keyName = _this.toKey(name);
        var keyValue = _this.toKey(value);
        var keyEnding = ending ? _this.toKey(ending) : "";

        if (keyEnding) {
            keyValue = keyValue == undefined ? keyValue : keyValue.toString() + keyEnding;
        }

        var filterItems = _this.items.filter(function (x) {
            return x.name == keyName;
        });
        if (filterItems && filterItems.length) {
            var item = filterItems[0];
            item.value = keyValue;
        } else {
            _this.items.push({ name: keyName, value: keyValue });
        }
    };
    this.addPx = function (name, value) {
        var ending = undefined;
        if (isRawNumber(value)) {
            ending = "px";
        }

        _this.add(name, value, ending);
    };

    this.toKey = function (x) {
        return x instanceof String ? x.toLowerCase() : x;
    };

    this.toString = function () {
        var result = _this.items.map(function (x) {
            return x.value == undefined ? "" : x.name + ":" + x.value + ";";
        });
        return result.join('');
    };

    function isRawNumber(instance) {
        var result = false;

        if (instance) {
            var instanceString = instance.toString();
            result = parseFloat(instanceString).toString() == instanceString;
        }

        return result;
    }
};

exports.default = StyleSheetBuilder;