﻿const StyleSheetBuilder = function () {
    this.items = [];
    this.add = (name, value, ending) => {

        var keyName = this.toKey(name);
        var keyValue = this.toKey(value);
        var keyEnding = ending ? this.toKey(ending) : "";

        if (keyEnding) {
            keyValue = keyValue == undefined ? keyValue : (keyValue.toString() + keyEnding);
        }

        var filterItems = this.items.filter(x=>x.name == keyName);
        if (filterItems && filterItems.length) {
            var item = filterItems[0];
            item.value = keyValue;
        }
        else {
            this.items.push({ name: keyName, value: keyValue });
        }
    }
    this.addPx = (name, value) => {
        var ending = undefined;
        if (isRawNumber(value)) {
            ending = "px";
        }

        this.add(name, value, ending);
    };

    this.toKey = (x) => {
        return (x instanceof String) ? x.toLowerCase() : x;
    }

    this.toString = () => {
        var result = this.items.map(x=> {
            return x.value == undefined ? "" : (x.name + ":" + x.value + ";");
        });
        return result.join('');
    }

    function isRawNumber(instance) {
        var result = false;

        if (instance) {
            var instanceString = instance.toString();
            result = parseFloat(instanceString).toString() == instanceString;
        }

        return result;
    }
}

export default StyleSheetBuilder;